/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  atstat.plx

\***************************************************************************/

#if !defined(ATSTAT_PLX)
#define ATSTAT_PLX
#define ll3atstat_name "ATSTAT"
/* Argument definitions for C-callable functions */
#define LPI_ATST_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lubyte functype,\
 LpiRangeType theRange,\
 lptr(lfloat10) outfloat)
#define LPI_ATST_COUNT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiRangeType theRange,\
 lptr(lslong) theCount)
/* Funtion prototypes for C-callabel functions */
lexppro (lsshort, lpi_atst, LPI_ATST_ARGS);
lexppro (lsshort, lpi_atst_count, LPI_ATST_COUNT_ARGS);
typedef struct {
    lexpptr (lsshort, lpi_atst, LPI_ATST_ARGS);
    lexpptr (lsshort, lpi_atst_count, LPI_ATST_COUNT_ARGS);
} atst_exports;
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
#include "LPICODE.H"
#if defined(NOGLOBALDATA)
#define LPI_ATST_GLOBAL_REF  LPI_CALL_DATA->atst_global
#define LPI_ATST_TABLE_REF   LPI_CALL_DATA->atst_table
#else
#define LPI_ATST_GLOBAL_REF  lts_atst_global
#define LPI_ATST_TABLE_REF   lts_atst_table
#endif
#define LpiAtstAvg(arg1, arg2) \
    (*LPI_ATST_TABLE_REF->lpi_atst)(LPI_ATST_GLOBAL_REF, I_AVG, arg1, arg2)
#define LpiAtstCount(arg1, arg2) \
    (*LPI_ATST_TABLE_REF->lpi_atst_count)(LPI_ATST_GLOBAL_REF, arg1, arg2)
#define LpiAtstMax(arg1, arg2) \
    (*LPI_ATST_TABLE_REF->lpi_atst)(LPI_ATST_GLOBAL_REF, I_MAX, arg1, arg2)
#define LpiAtstMin(arg1, arg2) \
    (*LPI_ATST_TABLE_REF->lpi_atst)(LPI_ATST_GLOBAL_REF, I_MIN, arg1, arg2)
#define LpiAtstStD(arg1, arg2) \
    (*LPI_ATST_TABLE_REF->lpi_atst)(LPI_ATST_GLOBAL_REF, I_STD, arg1, arg2)
#define LpiAtstStDS(arg1, arg2) \
    (*LPI_ATST_TABLE_REF->lpi_atst)(LPI_ATST_GLOBAL_REF, I_STDS, arg1, arg2)
#define LpiAtstSum(arg1, arg2) \
    (*LPI_ATST_TABLE_REF->lpi_atst)(LPI_ATST_GLOBAL_REF, I_SUM, arg1, arg2)
#define LpiAtstVar(arg1, arg2) \
    (*LPI_ATST_TABLE_REF->lpi_atst)(LPI_ATST_GLOBAL_REF, I_VAR, arg1, arg2)
#define LpiAtstVarS(arg1, arg2) \
    (*LPI_ATST_TABLE_REF->lpi_atst)(LPI_ATST_GLOBAL_REF, I_VARS, arg1, arg2)
#endif
#endif
