/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  window.plx

\***************************************************************************/

#if !defined(WINDOW_PLX)
#define WINDOW_PLX
/* definitions used by some of these functions */
#define USE_DEFAULT     9999
#define USE_LDEFAULT    9999L
#define ON              LTRUE
#define OFF             LFALSE
#define LPI_DSP_STRING_BUFLEN   8
/* Argument definitions for C-callable functions */
#define LPI_WIN_DEST_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(LpiWindowType) mds)
#define LPI_WIN_CONST_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(LpiWindowType) mds,\
 lslong ncols,\
 lslong nrows,\
 lushort border)
#define LPI_WIN_GET_SIZE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lptr(lushort) width,\
 lptr(lushort) height)
#define LPI_WIN_SET_DISP_MODE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lushort mode)
#define LPI_WIN_GET_DISP_MODE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lptr(lushort) mode)
#define LPI_WIN_SET_POSITION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lslong column,\
 lslong row)
#define LPI_WIN_GET_POSITION_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lptr(lushort) column,\
 lptr(lushort) row)
#define LPI_WIN_SET_CURSOR_POSITN_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lslong column,\
 lslong row)
#define LPI_WIN_GET_CURSOR_POSITN_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lptr(lushort) column,\
 lptr(lushort) row)
#define LPI_WIN_SET_FOREGROUND_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lushort fgattr,\
 lushort areaflag)
#define LPI_WIN_GET_FOREGROUND_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lptr(lushort) foreground,\
 lushort areaflag)
#define LPI_WIN_SET_BACKGROUND_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lushort bgattr,\
 lushort flag)
#define LPI_WIN_GET_BACKGROUND_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lptr(lushort) background,\
 lushort flag)
#define LPI_WIN_REPLACE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lslong col,\
 lslong row,\
 lmhdl(lmbcs) mstr,\
 lptr(lushort) overflow)
#define LPI_WIN_SET_BORDER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lushort borderflg)
#define LPI_WIN_GET_BORDER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lptr(lushort) borderflg)
#define LPI_WIN_SET_ENABLED_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lbool setting)
#define LPI_WIN_GET_ENABLED_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lptr(lbool) setting)
#define LPI_WIN_SET_CLEAR_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lbool setting)
#define LPI_WIN_GET_CLEAR_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lptr(lbool) setting)
#define LPI_WIN_SHOW_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds)
#define LPI_WIN_SET_CURSORON_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lbool vflag)
#define LPI_WIN_GET_CURSORON_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lptr(lbool) vflag)
#define LPI_WIN_SET_TITLE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lmhdl(lmbcs) pname)
#define LPI_WIN_GET_TITLE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lptr(lmhdl(lmbcs)) pname)
#define LPI_WIN_ERASE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lslong cols,\
 lslong rows)
#define LPI_WIN_PAINT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lslong cols,\
 lslong rows)
#define LPI_WIN_SELECT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType wdmp,\
 lslong col,\
 lslong row,\
 lptr(lmhdl(lmbcs)) str,\
 lslong chr_cnt)
#define LPI_WIN_GET_CHARACTERISTCS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType wdmp,\
 lslong col,\
 lslong row,\
 lptr(lushort) fgp,\
 lptr(lushort) bgp,\
 lptr(lslong) bytep)
#define LPI_WIN_COPY_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType mds,\
 lptr(LpiWindowType) new)
#define LPI_WIN_STRING_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiWindowType winid,\
 lptr(lmhdl(lmbcs)) mystr)
#define LPI_DSP_DEST_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(LpiDisplayType) mds)
#define LPI_DSP_CONST_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(LpiDisplayType) mds)
#define LPI_DSP_STRING_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiDisplayType dispid,\
 lptr(lmbcs) mystr)
#define LPI_DSP_GET_SIZE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiDisplayType mds,\
 lptr(lushort) width,\
 lptr(lushort) height)
#define LPI_DSP_SET_PANELON_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiDisplayType mds,\
 lbool setting ,\
 lushort clear_panel)
#define LPI_DSP_GET_PANELON_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiDisplayType mds,\
 lptr(lbool) panel)
#define LPI_DSP_SET_WINDOWSON_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiDisplayType mds,\
 lbool setting)
#define LPI_DSP_GET_WINDOWSON_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiDisplayType mds,\
 lptr(lbool) window)
#define LPI_DSP_SET_FRAMEON_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiDisplayType mds,\
 lbool setting)
#define LPI_DSP_GET_FRAMEON_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiDisplayType mds,\
 lptr(lbool) border)
#define LPI_DSP_SET_ENABLED_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiDisplayType mds,\
 lbool setting,\
 lushort areaflag)
#define LPI_DSP_GET_ENABLED_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiDisplayType mds,\
 lptr(lbool) setting,\
 lushort areaflag)
#define LPI_DSP_REFRESH_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiDisplayType mds,\
 lushort areaflag)
#define LPI_DSP_CLEAR_ARGS (\
 lptr(CONTEXT) LpiContext,\
 LpiDisplayType mds,\
 lushort areaflag)
/* typedefs for C callable functions */
/* typedefs for WINDOW functions */
lexppro (lsshort, lpi_win_const, LPI_WIN_CONST_ARGS);
lexppro (lsshort, lpi_win_dest, LPI_WIN_DEST_ARGS);
lexppro (lsshort, lpi_win_get_size, LPI_WIN_GET_SIZE_ARGS);
lexppro (lsshort, lpi_win_set_disp_mode, LPI_WIN_SET_DISP_MODE_ARGS);
lexppro (lsshort, lpi_win_get_disp_mode, LPI_WIN_GET_DISP_MODE_ARGS);
lexppro (lsshort, lpi_win_set_position, LPI_WIN_SET_POSITION_ARGS);
lexppro (lsshort, lpi_win_get_position, LPI_WIN_GET_POSITION_ARGS);
lexppro (lsshort, lpi_win_set_cursor_position, LPI_WIN_SET_CURSOR_POSITN_ARGS);
lexppro (lsshort, lpi_win_get_cursor_position, LPI_WIN_GET_CURSOR_POSITN_ARGS);
lexppro (lsshort, lpi_win_set_foreground, LPI_WIN_SET_FOREGROUND_ARGS);
lexppro (lsshort, lpi_win_get_foreground, LPI_WIN_GET_FOREGROUND_ARGS);
lexppro (lsshort, lpi_win_set_background, LPI_WIN_SET_BACKGROUND_ARGS);
lexppro (lsshort, lpi_win_get_background, LPI_WIN_GET_BACKGROUND_ARGS);
lexppro (lsshort, lpi_win_replace, LPI_WIN_REPLACE_ARGS);
lexppro (lsshort, lpi_win_set_border, LPI_WIN_SET_BORDER_ARGS);
lexppro (lsshort, lpi_win_get_border, LPI_WIN_GET_BORDER_ARGS);
lexppro (lsshort, lpi_win_set_enabled, LPI_WIN_SET_ENABLED_ARGS);
lexppro (lsshort, lpi_win_get_enabled, LPI_WIN_GET_ENABLED_ARGS);
lexppro (lsshort, lpi_win_set_clear, LPI_WIN_SET_CLEAR_ARGS);
lexppro (lsshort, lpi_win_get_clear, LPI_WIN_GET_CLEAR_ARGS);
lexppro (lsshort, lpi_win_show, LPI_WIN_SHOW_ARGS);
lexppro (lsshort, lpi_win_set_cursoron, LPI_WIN_SET_CURSORON_ARGS);
lexppro (lsshort, lpi_win_get_cursoron, LPI_WIN_GET_CURSORON_ARGS);
lexppro (lsshort, lpi_win_set_title, LPI_WIN_SET_TITLE_ARGS);
lexppro (lsshort, lpi_win_get_title, LPI_WIN_GET_TITLE_ARGS);
lexppro (lsshort, lpi_win_erase, LPI_WIN_ERASE_ARGS);
lexppro (lsshort, lpi_win_paint, LPI_WIN_PAINT_ARGS);
lexppro (lsshort, lpi_win_select, LPI_WIN_SELECT_ARGS);
lexppro (lsshort, lpi_win_get_characteristics, LPI_WIN_GET_CHARACTERISTCS_ARGS);
lexppro (lsshort, lpi_win_copy, LPI_WIN_COPY_ARGS);
lexppro (lsshort, lpi_win_string, LPI_WIN_STRING_ARGS);
/* typedefs for DISPLAY functions */
lexppro (lsshort, lpi_dsp_const, LPI_DSP_CONST_ARGS);
lexppro (lsshort, lpi_dsp_dest, LPI_DSP_DEST_ARGS);
lexppro (lsshort, lpi_dsp_get_size, LPI_DSP_GET_SIZE_ARGS);
lexppro (lsshort, lpi_dsp_set_panelon, LPI_DSP_SET_PANELON_ARGS);
lexppro (lsshort, lpi_dsp_get_panelon, LPI_DSP_GET_PANELON_ARGS);
lexppro (lsshort, lpi_dsp_set_windowson, LPI_DSP_SET_WINDOWSON_ARGS);
lexppro (lsshort, lpi_dsp_get_windowson, LPI_DSP_GET_WINDOWSON_ARGS);
lexppro (lsshort, lpi_dsp_set_frameon, LPI_DSP_SET_FRAMEON_ARGS);
lexppro (lsshort, lpi_dsp_get_frameon, LPI_DSP_GET_FRAMEON_ARGS);
lexppro (lsshort, lpi_dsp_set_enabled, LPI_DSP_SET_ENABLED_ARGS);
lexppro (lsshort, lpi_dsp_get_enabled, LPI_DSP_GET_ENABLED_ARGS);
lexppro (lsshort, lpi_dsp_refresh, LPI_DSP_REFRESH_ARGS);
lexppro (lsshort, lpi_dsp_string, LPI_DSP_STRING_ARGS);
lexppro (lsshort, lpi_dsp_clear, LPI_DSP_CLEAR_ARGS);
/* Pointers to C callable functions */
typedef struct {
    lexpptr (lsshort, lpi_win_const, LPI_WIN_CONST_ARGS);
    lexpptr (lsshort, lpi_win_dest, LPI_WIN_DEST_ARGS);
    lexpptr (lsshort, lpi_win_get_size, LPI_WIN_GET_SIZE_ARGS);
    lexpptr (lsshort, lpi_win_set_disp_mode, LPI_WIN_SET_DISP_MODE_ARGS);
    lexpptr (lsshort, lpi_win_get_disp_mode, LPI_WIN_GET_DISP_MODE_ARGS);
    lexpptr (lsshort, lpi_win_set_position, LPI_WIN_SET_POSITION_ARGS);
    lexpptr (lsshort, lpi_win_get_position, LPI_WIN_GET_POSITION_ARGS);
    lexpptr (lsshort, lpi_win_set_cursor_position, LPI_WIN_SET_CURSOR_POSITN_ARGS);
    lexpptr (lsshort, lpi_win_get_cursor_position, LPI_WIN_GET_CURSOR_POSITN_ARGS);
    lexpptr (lsshort, lpi_win_set_foreground, LPI_WIN_SET_FOREGROUND_ARGS);
    lexpptr (lsshort, lpi_win_get_foreground, LPI_WIN_GET_FOREGROUND_ARGS);
    lexpptr (lsshort, lpi_win_set_background, LPI_WIN_SET_BACKGROUND_ARGS);
    lexpptr (lsshort, lpi_win_get_background, LPI_WIN_GET_BACKGROUND_ARGS);
    lexpptr (lsshort, lpi_win_replace, LPI_WIN_REPLACE_ARGS);
    lexpptr (lsshort, lpi_win_set_border, LPI_WIN_SET_BORDER_ARGS);
    lexpptr (lsshort, lpi_win_get_border, LPI_WIN_GET_BORDER_ARGS);
    lexpptr (lsshort, lpi_win_set_enabled, LPI_WIN_SET_ENABLED_ARGS);
    lexpptr (lsshort, lpi_win_get_enabled, LPI_WIN_GET_ENABLED_ARGS);
    lexpptr (lsshort, lpi_win_set_clear, LPI_WIN_SET_CLEAR_ARGS);
    lexpptr (lsshort, lpi_win_get_clear, LPI_WIN_GET_CLEAR_ARGS);
    lexpptr (lsshort, lpi_win_show, LPI_WIN_SHOW_ARGS);
    lexpptr (lsshort, lpi_win_set_cursoron, LPI_WIN_SET_CURSORON_ARGS);
    lexpptr (lsshort, lpi_win_get_cursoron, LPI_WIN_GET_CURSORON_ARGS);
    lexpptr (lsshort, lpi_win_set_title, LPI_WIN_SET_TITLE_ARGS);
    lexpptr (lsshort, lpi_win_get_title, LPI_WIN_GET_TITLE_ARGS);
    lexpptr (lsshort, lpi_win_erase, LPI_WIN_ERASE_ARGS);
    lexpptr (lsshort, lpi_win_paint, LPI_WIN_PAINT_ARGS);
    lexpptr (lsshort, lpi_win_select, LPI_WIN_SELECT_ARGS);
    lexpptr (lsshort, lpi_win_get_characteristics, LPI_WIN_GET_CHARACTERISTCS_ARGS);
    lexpptr (lsshort, lpi_win_copy, LPI_WIN_COPY_ARGS);
    lexpptr (lsshort, lpi_win_string, LPI_WIN_STRING_ARGS);
    /* typedefs for DISPLAY functions */
    lexpptr (lsshort, lpi_dsp_const, LPI_DSP_CONST_ARGS);
    lexpptr (lsshort, lpi_dsp_dest, LPI_DSP_DEST_ARGS);
    lexpptr (lsshort, lpi_dsp_get_size, LPI_DSP_GET_SIZE_ARGS);
    lexpptr (lsshort, lpi_dsp_set_panelon, LPI_DSP_SET_PANELON_ARGS);
    lexpptr (lsshort, lpi_dsp_get_panelon, LPI_DSP_GET_PANELON_ARGS);
    lexpptr (lsshort, lpi_dsp_set_windowson, LPI_DSP_SET_WINDOWSON_ARGS);
    lexpptr (lsshort, lpi_dsp_get_windowson, LPI_DSP_GET_WINDOWSON_ARGS);
    lexpptr (lsshort, lpi_dsp_set_frameon, LPI_DSP_SET_FRAMEON_ARGS);
    lexpptr (lsshort, lpi_dsp_get_frameon, LPI_DSP_GET_FRAMEON_ARGS);
    lexpptr (lsshort, lpi_dsp_set_enabled, LPI_DSP_SET_ENABLED_ARGS);
    lexpptr (lsshort, lpi_dsp_get_enabled, LPI_DSP_GET_ENABLED_ARGS);
    lexpptr (lsshort, lpi_dsp_refresh, LPI_DSP_REFRESH_ARGS);
    lexpptr (lsshort, lpi_dsp_string, LPI_DSP_STRING_ARGS);
    lexpptr (lsshort, lpi_dsp_clear, LPI_DSP_CLEAR_ARGS);
} win_exports;
#define ll3window_name "WINDOW"
/* macros for WINDOW ADT functions */
#if defined(LPIXPORT_H)
#if defined(NOGLOBALDATA)
#define LPI_WIN_GLOBAL_REF  LPI_CALL_DATA->win_global
#define LPI_WIN_TABLE_REF   LPI_CALL_DATA->win_table
#else
#define LPI_WIN_GLOBAL_REF  lts_win_global
#define LPI_WIN_TABLE_REF   lts_win_table
#endif
#define LpiWinConstructDefault(xADTdata)                \
        (*LPI_WIN_TABLE_REF->lpi_win_const)      \
        (LPI_WIN_GLOBAL_REF, xADTdata, USE_LDEFAULT, USE_LDEFAULT, 0)
#define LpiWinConstructDefaultBorder(xADTdata, arg1)    \
        (*LPI_WIN_TABLE_REF->lpi_win_const)      \
        (LPI_WIN_GLOBAL_REF, xADTdata, USE_LDEFAULT, USE_LDEFAULT, arg1)
#define LpiWinConstructSize(xADTdata, arg1, arg2)       \
        (*LPI_WIN_TABLE_REF->lpi_win_const)      \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2, 0)
#define LpiWinConstructSizeBorder(xADTdata, arg1, arg2, arg3)   \
        (*LPI_WIN_TABLE_REF->lpi_win_const)              \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2, arg3)
#define LpiWinDestroy(xADTdata)                         \
        (*LPI_WIN_TABLE_REF->lpi_win_dest)       \
        (LPI_WIN_GLOBAL_REF, xADTdata)
#define LpiWinGetSize(xADTdata, arg1, arg2)             \
        (*LPI_WIN_TABLE_REF->lpi_win_get_size)   \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2 )
#define LpiWinGetHeight(xADTdata, arg1)                 \
        (*LPI_WIN_TABLE_REF->lpi_win_get_size)   \
        (LPI_WIN_GLOBAL_REF, xADTdata, LNULL, arg1)
#define LpiWinGetWidth(xADTdata, arg1)                  \
        (*LPI_WIN_TABLE_REF->lpi_win_get_size)   \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, LNULL )
#define LpiWinSetPosition(xADTdata, arg1, arg2)             \
        (*LPI_WIN_TABLE_REF->lpi_win_set_position)   \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2 )
#define LpiWinGetPosition(xADTdata, arg1, arg2)             \
        (*LPI_WIN_TABLE_REF->lpi_win_get_position)   \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWinGetRow(xADTdata, arg1)                        \
        (*LPI_WIN_TABLE_REF->lpi_win_get_position)   \
        (LPI_WIN_GLOBAL_REF, xADTdata, LNULL, arg1)
#define LpiWinGetColumn(xADTdata, arg1)                     \
        (*LPI_WIN_TABLE_REF->lpi_win_get_position)   \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, LNULL)
#define LpiWinSetColumn(xADTdata, arg1)                     \
        (*LPI_WIN_TABLE_REF->lpi_win_set_position)   \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, USE_LDEFAULT )
#define LpiWinSetRow(xADTdata, arg1)                        \
        (*LPI_WIN_TABLE_REF->lpi_win_set_position)   \
        (LPI_WIN_GLOBAL_REF, xADTdata, USE_LDEFAULT, arg1 )
#define LpiWinSetCursorPosition(xADTdata, arg1, arg2)                   \
        (*LPI_WIN_TABLE_REF->lpi_win_set_cursor_position)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2 )
#define LpiWinSetCursorColumn(xADTdata, arg1)                           \
        (*LPI_WIN_TABLE_REF->lpi_win_set_cursor_position)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, USE_LDEFAULT)
#define LpiWinSetCursorRow(xADTdata, arg1)                              \
        (*LPI_WIN_TABLE_REF->lpi_win_set_cursor_position)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, USE_LDEFAULT, arg1)
#define LpiWinGetCursorPosition(xADTdata, arg1, arg2)                   \
        (*LPI_WIN_TABLE_REF->lpi_win_get_cursor_position)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWinGetCursorRow(xADTdata, arg1)                              \
        (*LPI_WIN_TABLE_REF->lpi_win_get_cursor_position)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, LNULL, arg1)
#define LpiWinGetCursorColumn(xADTdata, arg1)                           \
        (*LPI_WIN_TABLE_REF->lpi_win_get_cursor_position)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, LNULL)
#define LpiWinSetForeground(xADTdata, arg1)                     \
        (*LPI_WIN_TABLE_REF->lpi_win_set_foreground)     \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, LPI_T_AREA_CURRENTAREA)
#define LpiWinSetForegroundArea(xADTdata, arg1, arg2)           \
        (*LPI_WIN_TABLE_REF->lpi_win_set_foreground)     \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWinGetForeground(xADTdata, arg1)                     \
        (*LPI_WIN_TABLE_REF->lpi_win_get_foreground)     \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, LPI_T_AREA_CURRENTAREA)
#define LpiWinGetForegroundArea(xADTdata, arg1, arg2)           \
        (*LPI_WIN_TABLE_REF->lpi_win_get_foreground)     \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWinSetBackground(xADTdata, arg1 )                    \
        (*LPI_WIN_TABLE_REF->lpi_win_set_background)     \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, LPI_T_AREA_CURRENTAREA)
#define LpiWinSetBackgroundArea(xADTdata, arg1, arg2)           \
        (*LPI_WIN_TABLE_REF->lpi_win_set_background)     \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWinGetBackground(xADTdata, arg1)                     \
        (*LPI_WIN_TABLE_REF->lpi_win_get_background)     \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, LPI_T_AREA_CURRENTAREA)
#define LpiWinGetBackgroundArea(xADTdata, arg1, arg2)    \
        (*LPI_WIN_TABLE_REF->lpi_win_get_background)     \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWinSelect(xADTdata,arg1,arg2,arg3,arg4)       \
        (*LPI_WIN_TABLE_REF->lpi_win_select)             \
        (LPI_WIN_GLOBAL_REF, xADTdata,arg1,arg2,arg3,arg4)
#define LpiWinReplaceCurrent(xADTdata, arg1, arg2 )      \
        (*LPI_WIN_TABLE_REF->lpi_win_replace)            \
        (LPI_WIN_GLOBAL_REF, xADTdata, USE_LDEFAULT, USE_LDEFAULT, arg1, arg2)
#define LpiWinReplaceRow(xADTdata, arg1, arg2, arg3)     \
        (*LPI_WIN_TABLE_REF->lpi_win_replace)            \
        (LPI_WIN_GLOBAL_REF, xADTdata, USE_LDEFAULT, arg1, arg2, arg3 )
#define LpiWinReplaceColumnRow(xADTdata, arg1, arg2, arg3, arg4 )\
        (*LPI_WIN_TABLE_REF->lpi_win_replace)            \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2, arg3, arg4 )
#define LpiWinSetBorder(xADTdata,arg1)                   \
        (*LPI_WIN_TABLE_REF->lpi_win_set_border)         \
        (LPI_WIN_GLOBAL_REF, xADTdata,arg1)
#define LpiWinGetBorder(xADTdata,arg1)                   \
        (*LPI_WIN_TABLE_REF->lpi_win_get_border)         \
        (LPI_WIN_GLOBAL_REF, xADTdata,arg1)
#define LpiWinSetEnabled(xADTdata, arg1)                 \
        (*LPI_WIN_TABLE_REF->lpi_win_set_enabled)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1)
#define LpiWinGetEnabled(xADTdata, arg1)                 \
        (*LPI_WIN_TABLE_REF->lpi_win_get_enabled)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1)
#define LpiWinSetClear(xADTdata, arg1)                   \
        (*LPI_WIN_TABLE_REF->lpi_win_set_clear)          \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1)
#define LpiWinGetClear(xADTdata, arg1)                   \
        (*LPI_WIN_TABLE_REF->lpi_win_get_clear)          \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1)
#define LpiWinShow(xADTdata)                             \
        (*LPI_WIN_TABLE_REF->lpi_win_show)               \
        (LPI_WIN_GLOBAL_REF, xADTdata)
#define LpiWinCharacteristics(xADTdata,arg1,arg2,arg3,arg4,arg5)\
        (*LPI_WIN_TABLE_REF->lpi_win_get_characteristics)\
        (LPI_WIN_GLOBAL_REF, xADTdata,arg1,arg2,arg3,arg4,arg5)
#define LpiWinSetCursorOn(xADTdata, arg1)                \
        (*LPI_WIN_TABLE_REF->lpi_win_set_cursoron)       \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1 )
#define LpiWinGetCursorOn(xADTdata, arg1)                \
        (*LPI_WIN_TABLE_REF->lpi_win_get_cursoron)       \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1 )
#define LpiWinSetTitle(xADTdata, arg1)                   \
        (*LPI_WIN_TABLE_REF->lpi_win_set_title)          \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1 )
#define LpiWinGetTitle(xADTdata, arg1)                   \
        (*LPI_WIN_TABLE_REF->lpi_win_get_title)          \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1 )
#define LpiWinErase(xADTdata)                            \
        (*LPI_WIN_TABLE_REF->lpi_win_erase)              \
        (LPI_WIN_GLOBAL_REF, xADTdata, USE_LDEFAULT, USE_LDEFAULT)
#define LpiWinEraseCoords(xADTdata, arg1, arg2)          \
        (*LPI_WIN_TABLE_REF->lpi_win_erase)              \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWinPaint(xADTdata, arg1, arg2)                \
        (*LPI_WIN_TABLE_REF->lpi_win_paint)              \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiWinCopy(xADTdata, arg1)                       \
        (*LPI_WIN_TABLE_REF->lpi_win_copy)               \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1)
#define LpiWinString(xADTdata, arg1)                     \
        (*LPI_WIN_TABLE_REF->lpi_win_string)             \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1)
/* macros for DISPLAY ADT functions */
#define LpiDspConstruct(xADTdata)                        \
        (*LPI_WIN_TABLE_REF->lpi_dsp_const)              \
        (LPI_WIN_GLOBAL_REF, xADTdata)
#define LpiDspDestroy(xADTdata)                          \
        (*LPI_WIN_TABLE_REF->lpi_dsp_dest)               \
        (LPI_WIN_GLOBAL_REF, xADTdata)
#define LpiDspGetSize(xADTdata, arg1, arg2)              \
        (*LPI_WIN_TABLE_REF->lpi_dsp_get_size)           \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2 )
#define LpiDspGetHeight(xADTdata, arg1)                  \
        (*LPI_WIN_TABLE_REF->lpi_dsp_get_size)           \
        (LPI_WIN_GLOBAL_REF, xADTdata, LNULL, arg1 )
#define LpiDspGetWidth(xADTdata, arg1)                   \
        (*LPI_WIN_TABLE_REF->lpi_dsp_get_size)           \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, LNULL )
#define LpiDspSetPanelOn(xADTdata, arg1)                 \
        (*LPI_WIN_TABLE_REF->lpi_dsp_set_panelon)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, LPI_T_PANELSETTING_ERASE )
#define LpiDspSetPanelOnAction(xADTdata, arg1, arg2)     \
        (*LPI_WIN_TABLE_REF->lpi_dsp_set_panelon)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2 )
#define LpiDspGetPanelOn(xADTdata, arg1)                 \
        (*LPI_WIN_TABLE_REF->lpi_dsp_get_panelon)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1 )
#define LpiDspSetWindowsOn(xADTdata, arg1)               \
        (*LPI_WIN_TABLE_REF->lpi_dsp_set_windowson)      \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1 )
#define LpiDspGetWindowsOn(xADTdata, arg1)               \
        (*LPI_WIN_TABLE_REF->lpi_dsp_get_windowson)      \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1 )
#define LpiDspSetFrameOn(xADTdata, arg1)                 \
        (*LPI_WIN_TABLE_REF->lpi_dsp_set_frameon)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1 )
#define LpiDspGetFrameOn(xADTdata, arg1)                 \
        (*LPI_WIN_TABLE_REF->lpi_dsp_get_frameon)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1 )
#define LpiDspSetEnabled(xADTdata, arg1)                 \
        (*LPI_WIN_TABLE_REF->lpi_dsp_set_enabled)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, LPI_T_DISPLAYAREA_ENTIREDISPLAY)
#define LpiDspSetEnabledArea(xADTdata, arg1, arg2)       \
        (*LPI_WIN_TABLE_REF->lpi_dsp_set_enabled)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiDspGetEnabled(xADTdata, arg1)                 \
        (*LPI_WIN_TABLE_REF->lpi_dsp_get_enabled)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, LPI_T_DISPLAYAREA_ENTIREDISPLAY)
#define LpiDspGetEnabledArea(xADTdata, arg1, arg2)       \
        (*LPI_WIN_TABLE_REF->lpi_dsp_get_enabled)        \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1, arg2)
#define LpiDspRefresh(xADTdata )                         \
        (*LPI_WIN_TABLE_REF->lpi_dsp_refresh)            \
        (LPI_WIN_GLOBAL_REF, xADTdata, LPI_T_DISPLAYAREA_ENTIREDISPLAY)
#define LpiDspRefreshArea(xADTdata, arg1)                \
        (*LPI_WIN_TABLE_REF->lpi_dsp_refresh)            \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1)
#define LpiDspString(xADTdata, arg1)                     \
        (*LPI_WIN_TABLE_REF->lpi_dsp_string)             \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1)
#define LpiDspClear(xADTdata)                            \
        (*LPI_WIN_TABLE_REF->lpi_dsp_clear)              \
        (LPI_WIN_GLOBAL_REF, xADTdata, LPI_T_DISPLAYAREA_ENTIREDISPLAY)
#define LpiDspClearArea(xADTdata,  arg1)                 \
        (*LPI_WIN_TABLE_REF->lpi_dsp_clear)              \
        (LPI_WIN_GLOBAL_REF, xADTdata, arg1)
#endif
#endif
