;***************************************************************************
; This is the .ASM file for the NEWTON-RAPHSON  sample program.
;***************************************************************************


   DOSSEG

addn_text segment byte public 'CODE'
        assume cs:addn_text

;************************************************************************
;
; Externally define the bind and unbind function addresses
;
;************************************************************************
        extrn newt_bind:far
        extrn newt_unbind:far

linkbase:
addn_text ends

NULL_DATA segment para public 'FAR_BSS'
NULL_DATA ends

DGROUP group  _DATA
_DATA  segment  word public 'DATA'
_DATA  ends

addn_text segment

;************************************************************************
;
; Declare storage for the address of the bind and unbind function addresses
;
;************************************************************************
        dd newt_bind
        dd newt_unbind
        dw seg NULL_DATA        ; reference for DOS/16M

addn_text ends

;************************************************************************
;dummy stack to prevent linker warning
;************************************************************************

stack           segment stack
stack           ends

      end linkbase
