--**************************************************************************
--
--   Copyright (C) 1991-1994 Lotus Development Corporation.
--   All rights reserved.
--
--   1.  Lotus grants you a non-exclusive royalty-free right to use and modify
--       the source code version and to reproduce and distribute the object
--       code version of the Example Programs provided in the Toolkit, provided
--       that you:
--
--       a) distribute the Example Programs only in conjunction with and as a
--          part of your software application product which is designed as an
--          add-in to Lotus 1-2-3, and
--
--       b) do not represent your product to be a product of Lotus Development
--          Corporation.
--
--   2.  The Example Programs are provided as is, without warranty of any kind,
--       either express or implied, including, without limitation, the implied
--       warranties of merchantability of fitness for a particular purpose.
--
--   File Name:  tstsumsq.pl
--
--**************************************************************************

use sumsq
use range
use register

procedure initialize is

    register ( "sumsquare", atfunction )

end procedure initialize


procedure sumsquare (Range theRange)
            RETURNS (float theSum) is

            theSum = sum_of_squares (theRange)
            except on others do
                theSum = -1
            end except

end procedure sumsquare

