/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  atdate.plx

\***************************************************************************/

#if !defined(ATDATE_PLX)
#define ATDATE_PLX
#define ll3atdate_name "ATDATE"
/* Argument defintions for C-callable functions */
#define LPI_ATD_D360_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 startDate,\
 lfloat10 endDate,\
 lptr(lslong) outval)
#define LPI_ATD_DATE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 year,\
 lfloat10 month,\
 lfloat10 day,\
 lptr(lslong) outval)
#define LPI_ATD_DATEVALUE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) date,\
 lptr(lslong) outval)
#define LPI_ATD_DAY_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 dateNumber,\
 lptr(lslong) outval)
#define LPI_ATD_HOUR_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 timeNumber,\
 lptr(lslong) outval)
#define LPI_ATD_MINUTE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 timeNumber,\
 lptr(lslong) outval)
#define LPI_ATD_MONTH_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 dateNumber,\
 lptr(lslong) outval)
#define LPI_ATD_NOW_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(lfloat10) outval)
#define LPI_ATD_SECOND_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 timeNumber,\
 lptr(lslong) outval)
#define LPI_ATD_TIME_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 theHour,\
 lfloat10 theMinute,\
 lfloat10 theSecond,\
 lptr(lfloat10) outflt)
#define LPI_ATD_TIMEVALUE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) time,\
 lptr(lfloat10) outflt)
#define LPI_ATD_TODAY_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(lslong) outval)
#define LPI_ATD_YEAR_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 dateNumber,\
 lptr(lslong) outval)
/* Function prototypes for C-callable functions */
lexppro (lsshort, lpi_atd_d360, LPI_ATD_D360_ARGS);
lexppro (lsshort, lpi_atd_date, LPI_ATD_DATE_ARGS);
lexppro (lsshort, lpi_atd_datevalue, LPI_ATD_DATEVALUE_ARGS);
lexppro (lsshort, lpi_atd_day, LPI_ATD_DAY_ARGS);
lexppro (lsshort, lpi_atd_hour, LPI_ATD_HOUR_ARGS);
lexppro (lsshort, lpi_atd_minute, LPI_ATD_MINUTE_ARGS);
lexppro (lsshort, lpi_atd_month, LPI_ATD_MONTH_ARGS);
lexppro (lsshort, lpi_atd_now, LPI_ATD_NOW_ARGS);
lexppro (lsshort, lpi_atd_second, LPI_ATD_SECOND_ARGS);
lexppro (lsshort, lpi_atd_time, LPI_ATD_TIME_ARGS);
lexppro (lsshort, lpi_atd_timevalue, LPI_ATD_TIMEVALUE_ARGS);
lexppro (lsshort, lpi_atd_today, LPI_ATD_TODAY_ARGS);
lexppro (lsshort, lpi_atd_year, LPI_ATD_YEAR_ARGS);
typedef struct {
      lexpptr (lsshort, lpi_atd_d360, LPI_ATD_D360_ARGS);
      lexpptr (lsshort, lpi_atd_date, LPI_ATD_DATE_ARGS);
      lexpptr (lsshort, lpi_atd_datevalue, LPI_ATD_DATEVALUE_ARGS);
      lexpptr (lsshort, lpi_atd_day, LPI_ATD_DAY_ARGS);
      lexpptr (lsshort, lpi_atd_hour, LPI_ATD_HOUR_ARGS);
      lexpptr (lsshort, lpi_atd_minute, LPI_ATD_MINUTE_ARGS);
      lexpptr (lsshort, lpi_atd_month, LPI_ATD_MONTH_ARGS);
      lexpptr (lsshort, lpi_atd_now, LPI_ATD_NOW_ARGS);
      lexpptr (lsshort, lpi_atd_second, LPI_ATD_SECOND_ARGS);
      lexpptr (lsshort, lpi_atd_time, LPI_ATD_TIME_ARGS);
      lexpptr (lsshort, lpi_atd_timevalue, LPI_ATD_TIMEVALUE_ARGS);
      lexpptr (lsshort, lpi_atd_today, LPI_ATD_TODAY_ARGS);
      lexpptr (lsshort, lpi_atd_year, LPI_ATD_YEAR_ARGS);
} atd_exports;
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
#if defined(NOGLOBALDATA)
#define LPI_ATD_GLOBAL_REF  LPI_CALL_DATA->atd_global
#define LPI_ATD_TABLE_REF   LPI_CALL_DATA->atd_table
#else
#define LPI_ATD_GLOBAL_REF  lts_atd_global
#define LPI_ATD_TABLE_REF   lts_atd_table
#endif
#define LpiAtdD360(arg1, arg2, arg3) \
    (*LPI_ATD_TABLE_REF->lpi_atd_d360)(LPI_ATD_GLOBAL_REF, arg1, arg2, arg3)
#define LpiAtdDate(arg1, arg2, arg3, arg4) \
    (*LPI_ATD_TABLE_REF->lpi_atd_date)(LPI_ATD_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtdDateValue(arg1, arg2) \
    (*LPI_ATD_TABLE_REF->lpi_atd_datevalue)(LPI_ATD_GLOBAL_REF, arg1, arg2)
#define LpiAtdDay(arg1, arg2) \
    (*LPI_ATD_TABLE_REF->lpi_atd_day)(LPI_ATD_GLOBAL_REF, arg1, arg2)
#define LpiAtdHour(arg1, arg2) \
    (*LPI_ATD_TABLE_REF->lpi_atd_hour)(LPI_ATD_GLOBAL_REF, arg1, arg2)
#define LpiAtdMinute(arg1, arg2) \
    (*LPI_ATD_TABLE_REF->lpi_atd_minute)(LPI_ATD_GLOBAL_REF, arg1, arg2)
#define LpiAtdMonth(arg1, arg2) \
    (*LPI_ATD_TABLE_REF->lpi_atd_month)(LPI_ATD_GLOBAL_REF, arg1, arg2)
#define LpiAtdNow(arg1) \
    (*LPI_ATD_TABLE_REF->lpi_atd_now)(LPI_ATD_GLOBAL_REF, arg1)
#define LpiAtdSecond(arg1, arg2) \
    (*LPI_ATD_TABLE_REF->lpi_atd_second)(LPI_ATD_GLOBAL_REF, arg1, arg2)
#define LpiAtdTime(arg1, arg2, arg3, arg4) \
    (*LPI_ATD_TABLE_REF->lpi_atd_time)(LPI_ATD_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtdTimeValue(arg1, arg2) \
    (*LPI_ATD_TABLE_REF->lpi_atd_timevalue)(LPI_ATD_GLOBAL_REF, arg1, arg2)
#define LpiAtdToday(arg1) \
    (*LPI_ATD_TABLE_REF->lpi_atd_today)(LPI_ATD_GLOBAL_REF, arg1)
#define LpiAtdYear(arg1, arg2) \
    (*LPI_ATD_TABLE_REF->lpi_atd_year)(LPI_ATD_GLOBAL_REF, arg1, arg2)
#endif
#endif
