/***************************************************************************\

   Copyright (C) 1989-1994   Lotus Development Corporation.
   All rights reserved.

   File Name:  atstr.plx

\***************************************************************************/

#if !defined(ATSTR_PLX)
#define ATSTR_PLX
#define ll3atstr_name "ATSTR"
/* Argument definitions for C-callable functions */
#define LPI_ATSTR_EXACT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) str1,\
 lmhdl(lmbcs) str2,\
 lptr(lbool) matches)
#define LPI_ATSTR_FIND_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) search,\
 lmhdl(lmbcs) target,\
 lslong start,\
 lptr(lslong) result)
#define LPI_ATSTR_LEFT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) source,\
 lslong n,\
 lptr(lmhdl(lmbcs)) outstr)
#define LPI_ATSTR_LOWER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) source,\
 lptr(lmhdl(lmbcs)) outstr)
#define LPI_ATSTR_MID_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) source,\
 lslong start,\
 lslong n,\
 lptr(lmhdl(lmbcs)) outstr)
#define LPI_ATSTR_PROPER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) source,\
 lptr(lmhdl(lmbcs)) outstr)
#define LPI_ATSTR_REPEAT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) source,\
 lslong n,\
 lptr(lmhdl(lmbcs)) outstr)
#define LPI_ATSTR_REPLACE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) original,\
 lslong start,\
 lslong n,\
 lmhdl(lmbcs) new,\
 lptr(lmhdl(lmbcs)) outstr)
#define LPI_ATSTR_RIGHT_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) source,\
 lslong n,\
 lptr(lmhdl(lmbcs)) outstr)
#define LPI_ATSTR_STRING_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lfloat10 ival,\
 lslong dig,\
 lptr(lmhdl(lmbcs)) outstr)
#define LPI_ATSTR_UPPER_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) source,\
 lptr(lmhdl(lmbcs)) outstr)
#define LPI_ATSTR_VALUE_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) source,\
 lptr(lfloat10) outflt)
#define LPI_ATSTR_CHAR_ITOS_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lslong charcode,\
 lptr(lmbcs) outstr)
#define LPI_ATSTR_CHAR_STOI_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lmhdl(lmbcs) chmp,\
 lptr(lslong) thecode)
#define LPI_ATSTR_NEWLINE_ARGS (\
 lptr(CONTEXT)      LpiContext,\
 lptr(lmhdl(lmbcs)) newline)
#define LPI_ATSTR_LMBCS_GROUP_ARGS (\
 lptr(CONTEXT) LpiContext,\
 lptr(lslong) thecode)
/* typedefs for C callable functions */
lexppro (lsshort, lpi_atstr_exact, LPI_ATSTR_EXACT_ARGS);
lexppro (lsshort, lpi_atstr_find, LPI_ATSTR_FIND_ARGS);
lexppro (lsshort, lpi_atstr_left, LPI_ATSTR_LEFT_ARGS);
lexppro (lsshort, lpi_atstr_lower, LPI_ATSTR_LOWER_ARGS);
lexppro (lsshort, lpi_atstr_mid, LPI_ATSTR_MID_ARGS);
lexppro (lsshort, lpi_atstr_proper, LPI_ATSTR_PROPER_ARGS);
lexppro (lsshort, lpi_atstr_repeat, LPI_ATSTR_REPEAT_ARGS);
lexppro (lsshort, lpi_atstr_replace, LPI_ATSTR_REPLACE_ARGS);
lexppro (lsshort, lpi_atstr_right, LPI_ATSTR_RIGHT_ARGS);
lexppro (lsshort, lpi_atstr_string, LPI_ATSTR_STRING_ARGS);
lexppro (lsshort, lpi_atstr_upper, LPI_ATSTR_UPPER_ARGS);
lexppro (lsshort, lpi_atstr_value, LPI_ATSTR_VALUE_ARGS);
lexppro (lsshort, lpi_atstr_char_itos, LPI_ATSTR_CHAR_ITOS_ARGS);
lexppro (lsshort, lpi_atstr_char_stoi, LPI_ATSTR_CHAR_STOI_ARGS);
lexppro (lsshort, lpi_atstr_newline, LPI_ATSTR_NEWLINE_ARGS);
lexppro (lsshort, lpi_atstr_lmbcs_group, LPI_ATSTR_LMBCS_GROUP_ARGS);
/* pointers to C callable functions */
typedef struct {
    lexpptr (lsshort, lpi_atstr_exact, LPI_ATSTR_EXACT_ARGS);
    lexpptr (lsshort, lpi_atstr_find, LPI_ATSTR_FIND_ARGS);
    lexpptr (lsshort, lpi_atstr_left, LPI_ATSTR_LEFT_ARGS);
    lexpptr (lsshort, lpi_atstr_lower, LPI_ATSTR_LOWER_ARGS);
    lexpptr (lsshort, lpi_atstr_mid, LPI_ATSTR_MID_ARGS);
    lexpptr (lsshort, lpi_atstr_proper, LPI_ATSTR_PROPER_ARGS);
    lexpptr (lsshort, lpi_atstr_repeat, LPI_ATSTR_REPEAT_ARGS);
    lexpptr (lsshort, lpi_atstr_replace, LPI_ATSTR_REPLACE_ARGS);
    lexpptr (lsshort, lpi_atstr_right, LPI_ATSTR_RIGHT_ARGS);
    lexpptr (lsshort, lpi_atstr_string, LPI_ATSTR_STRING_ARGS);
    lexpptr (lsshort, lpi_atstr_upper, LPI_ATSTR_UPPER_ARGS);
    lexpptr (lsshort, lpi_atstr_value, LPI_ATSTR_VALUE_ARGS);
    lexpptr (lsshort, lpi_atstr_char_itos, LPI_ATSTR_CHAR_ITOS_ARGS);
    lexpptr (lsshort, lpi_atstr_char_stoi, LPI_ATSTR_CHAR_STOI_ARGS);
    lexpptr (lsshort, lpi_atstr_newline, LPI_ATSTR_NEWLINE_ARGS);
    lexpptr (lsshort, lpi_atstr_lmbcs_group, LPI_ATSTR_LMBCS_GROUP_ARGS);
} atstr_exports;
#define  LPI_ATSTR_CHAR_BUFLEN    4  /* SPR #121415, 10/30/90 HWG */
#define  LPI_ATSTR_NEWLINE_BUFLEN 5  /* SPR #121444, 11/01/90 HWG */
#if defined(LPIXPORT_H) /* macros to call the structure stuff */
#if defined(NOGLOBALDATA)
#define LPI_ATSTR_GLOBAL_REF  LPI_CALL_DATA->atstr_global
#define LPI_ATSTR_TABLE_REF   LPI_CALL_DATA->atstr_table
#else
#define LPI_ATSTR_GLOBAL_REF  lts_atstr_global
#define LPI_ATSTR_TABLE_REF   lts_atstr_table
#endif
#define LpiAtstrExact(arg1, arg2, arg3)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_exact)(LPI_ATSTR_GLOBAL_REF, arg1, arg2, arg3)
#define LpiAtstrFind(arg1, arg2, arg3, arg4)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_find)(LPI_ATSTR_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtstrLeft(arg1, arg2, arg3)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_left)(LPI_ATSTR_GLOBAL_REF, arg1, arg2, arg3)
#define LpiAtstrLower(arg1, arg2)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_lower)(LPI_ATSTR_GLOBAL_REF, arg1, arg2)
#define LpiAtstrMid(arg1, arg2, arg3, arg4)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_mid)(LPI_ATSTR_GLOBAL_REF, arg1, arg2, arg3, arg4)
#define LpiAtstrProper(arg1, arg2)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_proper)(LPI_ATSTR_GLOBAL_REF, arg1, arg2)
#define LpiAtstrRepeat(arg1, arg2, arg3)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_repeat)(LPI_ATSTR_GLOBAL_REF, arg1, arg2, arg3)
#define LpiAtstrReplace(arg1, arg2, arg3, arg4, arg5)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_replace)(LPI_ATSTR_GLOBAL_REF, arg1, arg2,arg3, arg4, arg5)
#define LpiAtstrRight(arg1, arg2, arg3)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_right)(LPI_ATSTR_GLOBAL_REF, arg1, arg2, arg3)
#define LpiAtstrString(arg1, arg2, arg3)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_string)(LPI_ATSTR_GLOBAL_REF, arg1, arg2, arg3)
#define LpiAtstrUpper(arg1, arg2)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_upper)(LPI_ATSTR_GLOBAL_REF, arg1, arg2)
#define LpiAtstrValue(arg1, arg2)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_value)(LPI_ATSTR_GLOBAL_REF, arg1, arg2)
#define LpiAtstrCharItoS(arg1, arg2) \
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_char_itos) (LPI_ATSTR_GLOBAL_REF, arg1, arg2)
#define LpiAtstrCharStoI(arg1, arg2)                       \
        (*LPI_ATSTR_TABLE_REF->lpi_atstr_char_stoi)  \
        (LPI_ATSTR_GLOBAL_REF, arg1, arg2)
#define LpiAtstrNewLine(arg1)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_newline )(LPI_ATSTR_GLOBAL_REF, arg1)
#define LpiAtstrLmbcsGroup(arg1)\
    (*LPI_ATSTR_TABLE_REF->lpi_atstr_lmbcs_group )(LPI_ATSTR_GLOBAL_REF, arg1)
#endif
#endif
